<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="java.io.FileInputStream"%>
<%@page import="java.util.Properties"%>
<%@page import="com.swiveltechnologies.client.PINsafeClient"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<%
   final String errorAttribute = "errror";
   final String usernameAttribute ="username";
   final String sessionidAttribute = "sessionid";
   final String passwordAttribute = "password";
   String comment = "";
      
   String defaultError = "An error occured, please check your<br />credentials. If the error persists<br /> contact your PINsafe Administrator.";
   int init = 0, sessionStart = 1, login = 2, complete = 3;
   int status= login;

   String password = "", otc = "", error="", sessionID = "", username = "";
   String OTC = "";
   
   PINsafeClient sc;
   boolean primary = false;
   Properties clientProps = new Properties();

   if(session.getAttribute("status") == null){
   	status = init;
   }else {
   	if ((request.getParameter("sessionstart") != null) || new String("sessionstart").equals(request.getParameter("action"))) {
      		status = sessionStart;
   	}
   }

   session.setAttribute("status", status);

   if(session.getAttribute("settings") == null){
       
   try {
	    FileInputStream is = new FileInputStream(
	            this.getServletContext().getRealPath("/WEB-INF/settings.xml"));
	    clientProps.loadFromXML(is);
	    sc = new PINsafeClient(clientProps);
	    if(sc.ping().equalsIgnoreCase("pass")){
	        primary = true;
	        session.setAttribute("settings", clientProps);
	    }
	} catch (Exception e) {
		error = e.getLocalizedMessage();
		
	} 
	if(!primary) {
	  try{
		  
	    FileInputStream is = new FileInputStream(
	            this.getServletContext().getRealPath("/WEB-INF/settings2.xml"));
	    clientProps.loadFromXML(is);
	    sc = new PINsafeClient(clientProps);
	    if(sc.ping().equalsIgnoreCase("pass")){
	        session.setAttribute("settings", clientProps);
	    }
	  }catch (Exception e) {
			error = e.getLocalizedMessage();
			
		} 
	}
   } else {
	   
       clientProps = (Properties)session.getAttribute("settings");
   }
	// read any parameters passed into the page
	// only allow username to passed in a GET
	username = (request.getParameter(usernameAttribute) != null ? request.getParameter(usernameAttribute) : "");
	username = (PINsafeClient.checkChars(username)? username : "");
	//
	if(request.getMethod().equalsIgnoreCase("POST")){
	password = (request.getParameter(passwordAttribute) != null ? request.getParameter(passwordAttribute) : "");
	if(clientProps.getProperty("password","false").equalsIgnoreCase("true")){
		password = (request.getParameter("password") != null ? request.getParameter("password") : "");
	}
	
	OTC = (request.getParameter("otc") != null ? request.getParameter("otc") : "");
			
	switch (status){
		
		//session start
		case(1):
			sc = new PINsafeClient(clientProps);
		    //Create an instance of the PINsafeClient and setup with he settings...
	        if(PINsafeClient.checkChars(username)){
	        
	        //Attempt to create a session...
	        sessionID = sc.startSession(username);
	        
	        if(sessionID.length() == 0){
	        	error = "Cannot start PINsafe Session";
	        	session.setAttribute("error", error);
	        	} else {
	        		error = "";
	        	}
	        } else {
	        	error = "Invalid Characters in username";
	        	session.setAttribute("error", error);
	        }
	
		break;
		
		case(2):
		{
		    //Perform login...
			sc = new PINsafeClient(clientProps);
		    if (sc.login(username, password, OTC)) {	
		
		    	//login successfull!
		    	
				/////////////////////////////////
		    	/////////////////////////////////
		    	// TODO: insert specific integration code here eg. create an OAM cookie
		    	/////////////////////////////////
		    	/////////////////////////////////
		    		    	
		    	status = complete;
		    	session.setAttribute("status", init);
		    	error = "";
		        
			} else {		
				
		        //Redirect user with error...
		        error="login failed";
			}
	
		}// end of  case
	}// end of switch
	}
%>

<%if(status != complete)  {%>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link type="text/css" rel="stylesheet" href="./client.css">
<title>PINsafe Login</title>
<script type="text/javascript" src="./login.js"></script>
</head>
<body onload="enable_buttons(); set_focus();">
	<form method="post" id="login-form"
		onkeypress="return handle_enter(event);" onkeyup="enable_buttons();"
		action="login.jsp">
		<input type="hidden" name="action" id="action" />
		<table id="box">
			<tr id="username-row">
				<td class="label">Username:</td>
				<td class="text"><input name="username" id="username"
					type="text" value="<%=username%>">
				</td>
			</tr>
			<tr id="otc-row">
				<td class="label">One Time Code:</td>
				<td class="text"><input name="otc" id="otc" type="password">
				</td>
			</tr>
			<%if(clientProps.getProperty("password", "false").equalsIgnoreCase("true"))
                {%>
			<tr id>
				<td class="label">Password:</td>
				<td class="text"><input name="password" id="password"
					type="password" value="">
				</td>
			</tr>
			<% } %>

			<tr id="buttons-row">
				<td>&nbsp;</td>
				<td><input name="sessionstart" id="sessionstart" type="submit"
					onclick="return check_username()" value="Get Image">&nbsp;
					<input name="login" id="login" type="submit"
					onclick="return check_pins(event);" value="login"></td>
			</tr>

			<% if (sessionID.length() > 0) {
  		if (clientProps.getProperty("imagessl","false").equalsIgnoreCase("true")) { %>
			<tr id="image-row">
				<td colspan="2"><img id="turing"
					src="https://<%=clientProps.getProperty("imageserver", "localhost")%>:<%=clientProps.getProperty("imageport", "8080")%>/<%=clientProps.getProperty("imagecontext", "pinsafe")%>/SCImage?sessionid=<%=sessionID%>" />
				</td>
			</tr>
			<% }else { %>
			<tr id="image-row">
				<td colspan="2"><img id="turing"
					src="http://<%=clientProps.getProperty("imageserver", "localhost")%>:<%=clientProps.getProperty("imageport", "8080")%>/<%=clientProps.getProperty("imagecontext", "pinsafe")%>/SCImage?sessionid=<%=sessionID%>" />
				</td>
			</tr>
			<% } %>
			<% } %>
			<% if(error.length() > 0) { %>
			<tr id="error-row">
				<td colspan="2">
					<div><%=error %></div></td>
			</tr>


			<% } %>
		</table>
	</form>
</body>
</html>
<%}  else {
	status = init;
	session.setAttribute("status", status);
	Properties props = (session.getAttribute("settings") != null ? (Properties) session.getAttribute("settings") : new Properties());
	String redirect = props.getProperty("redirect", "");
%>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<% if (redirect != "") { %>
<meta http-equiv="Refresh" content="10; URL=<%=redirect%>">
<% } %>
<link type="text/css" rel="stylesheet" href="./client.css">
<title>Login Complete</title>
</head>
<body>
	<table id="box">
		<tr>
			<td class="message">Login successful.<br> <% if (redirect != "") { %>
				Please wait while you are redirected. If your<br> browser
				doesn't automatically redirect <br /> click <a href="<%=redirect%>">here</a>
				to continue. <% } %>
			</td>
		</tr>
	</table>
</body>
</html>
<%} %>


